#include once "QLayout.bi"


declare function QBoxLayout_Constructor cdecl lib "QtWrapper" alias "QBoxLayout_Constructor" (byval d as integer, byval parent as any ptr) as any ptr
declare sub QBoxLayout_Destructor cdecl lib "QtWrapper" alias "QBoxLayout_Destructor" (byval object as any ptr)
declare sub QBoxLayout_addWidget cdecl lib "QtWrapper" alias "QBoxLayout_addWidget" (byval object as any ptr, byval w as any ptr, byval s as integer, byval a as integer)
declare sub QBoxLayout_addStrut cdecl lib "QtWrapper" alias "QBoxLayout_addStrut" (byval object as any ptr, byval s as integer)
declare sub QBoxLayout_addSpacing cdecl lib "QtWrapper" alias "QBoxLayout_addSpacing" (byval object as any ptr, byval s as integer)
declare sub QBoxLayout_addStretch cdecl lib "QtWrapper" alias "QBoxLayout_addStretch" (byval object as any ptr, byval s as integer)
declare sub QBoxLayout_insertWidget cdecl lib "QtWrapper" alias "QBoxLayout_insertWidget" (byval object as any ptr, byval index as integer, byval w as any ptr, byval s as integer, byval a as integer)
declare sub QBoxLayout_insertSpacing cdecl lib "QtWrapper" alias "QBoxLayout_insertSpacing" (byval object as any ptr, byval index as integer, byval s as integer)
declare sub QBoxLayout_insertStretch cdecl lib "QtWrapper" alias "QBoxLayout_insertStretch" (byval object as any ptr, byval index as integer, byval s as integer)





#macro QBoxLayout_Interface()
declare sub addWidget(byval w as QWidget ptr, byval s as integer = 0, byval a as integer = 0)
declare sub addStrut (byval s as integer)
declare sub addSpacing (byval s as integer)
declare sub addStretch (byval s as integer = 0)
declare sub insertWidget(byval index as integer, byval w as QWidget ptr, byval s as integer = 0, byval a as integer = 0)
declare sub insertStrut (byval index as integer, byval s as integer)
declare sub insertSpacing (byval index as integer, byval s as integer)
declare sub insertStretch (byval index as integer, byval s as integer = 0)
const LeftToRight as integer = 0
const RightToLeft as integer = 1
const TopToBottom as integer = 2
const BottomToTop as integer = 3

QLayout_Interface()
#endmacro








type QBoxLayout
    w_ptr as any ptr
    
    declare constructor (byval d as integer, byval parent as QWidget ptr = 0)
    declare destructor ()
    
    QBoxLayout_Interface()
end type












constructor QBoxLayout (byval d as integer, byval parent as QWidget ptr)
  w_ptr = QBoxLayout_Constructor(d,parent->w_ptr)
end constructor 


destructor QBoxLayout ()
  QBoxLayout_Destructor(w_ptr)
end destructor












#macro QBoxLayout_Extends(c)

sub c##.addWidget(byval w as QWidget ptr, byval s as integer = 0, byval a as integer = 0)
    QBoxLayout_addWidget(w_ptr, w->w_ptr, s, a)
end sub



sub c##.addStrut (byval s as integer)
    QBoxLayout_addStrut(w_ptr,s)
end sub



sub c##.addSpacing (byval s as integer)
    QBoxLayout_addSpacing(w_ptr,s)
end sub



sub c##.addStretch (byval s as integer)
    QBoxLayout_addStretch(w_ptr,s)
end sub




sub c##.insertWidget(byval index as integer, byval w as QWidget ptr, byval s as integer = 0, byval a as integer = 0)
    QBoxLayout_insertWidget(w_ptr,index, w->w_ptr, s, a)
end sub



sub c##.insertSpacing (byval index as integer, byval s as integer)
    QBoxLayout_insertSpacing(w_ptr,index,s)
end sub



sub c##.insertStretch (byval index as integer, byval s as integer)
    QBoxLayout_insertStretch(w_ptr,index,s)
end sub



QLayout_Extends(c)
#endmacro



QBoxLayout_Extends(QBoxLayout)