declare function QObject_Constructor cdecl lib "QtWrapper" alias "QObject_Constructor" (byval parent as any ptr = 0) as any ptr
declare sub QObject_Destructor cdecl lib "QtWrapper" alias "QObject_Destructor" (byval object as any ptr)
declare sub QObject_connect cdecl lib "QtWrapper" alias "QObject_connect" (byval sender as any ptr,byval signal as string, byval r as any ptr, byval slot as string)

type QObject
    w_ptr as any ptr
    
    declare constructor (byval parent as any ptr)
    declare destructor ()
    
    declare static sub connect(byval sender as any ptr,byval signal as string, byval r as any ptr, byval slot as string)
end type


#define Q_OBJECT(p) cptr(QObject ptr,p)

#macro QObject_Interface()
declare static sub connect(byval sender as any ptr,byval signal as string, byval r as any ptr, byval slot as string)
#endmacro

#macro QObject_Extends(c)
sub c##.connect(byval sender as any ptr,byval signal as string, byval r as any ptr, byval slot as string)
    QObject_connect(Q_Object(sender)->w_ptr,signal,Q_Object(r)->w_ptr,slot)
end sub

#endmacro



constructor QObject (byval parent as any ptr)
  w_ptr = QObject_Constructor(parent)
end constructor 


destructor QObject ()
  QObject_Destructor(w_ptr)
end destructor



sub QObject.connect(byval sender as any ptr,byval signal as string, byval r as any ptr, byval slot as string)
    QObject_connect(Q_Object(sender)->w_ptr,signal,Q_Object(r)->w_ptr,slot)
end sub