#include once "Qt.bi"
#include once "QObject.bi"

declare function QWidget_Constructor cdecl lib "QtWrapper" alias "QWidget_Constructor" (byval parent as any ptr = 0, byval flags as integer) as any ptr
declare sub QWidget_Destructor cdecl lib "QtWrapper" alias "QWidget_Destructor" (byval object as any ptr)
declare sub QWidget_Show cdecl lib "QtWrapper" alias "QWidget_Show" (byval object as any ptr)
declare sub QWidget_Move cdecl lib "QtWrapper" alias "QWidget_Move" (byval object as any ptr, byval x as integer, byval y as integer)
declare sub QWidget_Resize cdecl lib "QtWrapper" alias "QWidget_Resize" (byval object as any ptr, byval w as integer, byval h as integer)
declare sub QWidget_setAcceptDrops cdecl lib "QtWrapper" alias "QWidget_setAcceptDrops" (byval object as any ptr, byval b as integer)
declare sub QWidget_setMouseTracking cdecl lib "QtWrapper" alias "QWidget_setMouseTracking" (byval object as any ptr, byval b as integer)
declare sub QWidget_setEnabled cdecl lib "QtWrapper" alias "QWidget_setEnabled" (byval object as any ptr, byval b as integer)
declare sub QWidget_Close cdecl lib "QtWrapper" alias "QWidget_Close" (byval object as any ptr)
declare sub QWidget_Hide cdecl lib "QtWrapper" alias "QWidget_Hide" (byval object as any ptr)
declare sub QWidget_SetWindowOpacity cdecl lib "QtWrapper" alias "QWidget_setWindowOpacity" (byval object as any ptr, byval o as double)
declare sub QWidget_activateWindow cdecl lib "QtWrapper" alias "QWidget_activateWindow" (byval object as any ptr)
declare sub QWidget_setContentMargins cdecl lib "QtWrapper" alias "QWidget_setContentMargins" (byval object as any ptr, byval l as integer, byval t as integer, byval r as integer, byval b as integer)
declare sub QWidget_setToolTip cdecl lib "QtWrapper" alias "QWidget_setToolTip" (byval object as any ptr, byval tt as string)
declare sub QWidget_setCallback cdecl lib "QtWrapper" alias "QWidget_setCallback" (byval object as any ptr, byval n as string, byval callback as any ptr)
declare sub QWidget_callDefault cdecl lib "QtWrapper" alias "QWidget_callDefault" (byval object as any ptr, byval n as string, byval e as any ptr)


#macro QWidget_Interface()
declare sub setMouseTracking(byval b as integer)
declare sub setAcceptDrops(byval b as integer)
declare sub setEnabled(byval b as integer)
declare sub show()
declare sub move(byval x as integer, byval y as integer)
declare sub resize(byval w as integer, byval h as integer)
declare sub hide()
declare sub close()
declare sub setWindowOpacity(byval o as double)
declare sub activateWindow()
declare sub setContentMargins (byval l as integer, byval t as integer, byval r as integer, byval b as integer)
declare sub setToolTip (byval tt as string)

declare sub callDefault (byval n as string, byval e as any ptr)
declare sub setCallback (byval n as string,byval c as sub(byval object as any ptr, byval n as string, byval extra as any ptr))

QObject_Interface()
#endmacro

#define Q_WIDGET(p) cptr(QWidget ptr,p)





type QWidget
    w_ptr as any ptr
    
    declare constructor (byval parent as any ptr = 0, byval flags as integer = 0)
    declare destructor ()
    
    QWidget_Interface()
end type




constructor QWidget (byval parent as any ptr, byval flags as integer)
  w_ptr = QWidget_Constructor(parent,flags)
end constructor 


destructor QWidget ()
  QWidget_Destructor(w_ptr)
end destructor
















#macro QWidget_Extends(c)


sub c##.show()
    QWidget_Show(w_ptr)
end sub



sub c##.move(byval x as integer, byval y as integer)
    QWidget_Move(w_ptr,x,y)
end sub



sub c##.resize(byval w as integer, byval h as integer)
    QWidget_Resize(w_ptr,w,h)
end sub



sub c##.setMouseTracking(byval b as integer)
    QWidget_setMouseTracking(w_ptr,b)
end sub



sub c##.setAcceptDrops(byval b as integer)
    QWidget_setAcceptDrops(w_ptr,b)

end sub



sub c##.setEnabled(byval b as integer)
    QWidget_setEnabled(w_ptr,b)
end sub



sub c##.hide()
    QWidget_Hide(w_ptr)
end sub



sub c##.close()
    QWidget_Close(w_ptr)
end sub



sub c##.setWindowOpacity(byval o as double)
    QWidget_setWindowOpacity(w_ptr,o)
end sub




sub c##.setContentMargins (byval l as integer, byval t as integer, byval r as integer, byval b as integer)
    QWidget_setContentMargins(w_ptr,l,t,r,b)
end sub



sub c##.setToolTip (byval tt as string)
    QWidget_setToolTip(w_ptr,tt)
end sub



sub c##.setCallback (byval n as string,byval c as sub(byval object as any ptr, byval n as string, byval extra as any ptr))
    c##_setCallback(w_ptr,n,c)
end sub



sub c##.callDefault (byval n as string, byval e as any ptr)
    c##_callDefault (w_ptr,n,e)
end sub



QObject_Extends(c)
#endmacro




QWidget_Extends(QWidget)