#include <QtGui>
#include "Makros.h"

class PushButton : public QPushButton
{
public:
    QMap<QString,void (*)(void *object,char *name, void *event)> map;

    PushButton(QWidget *parent) : QPushButton(parent) {}
    PushButton(QString s,QWidget *parent) : QPushButton(s,parent) {}

    META_MAKRO2(QPushButton,PushButton);
};




extern "C" {








__declspec( dllexport ) void * __cdecl QPushButton_Constructor(void *parent)
{
    return new PushButton((QWidget*)parent);
}



__declspec( dllexport ) void * __cdecl QPushButton_Constructor_2(char *text, void *parent)
{
    return new PushButton(text,(QWidget*)parent);
}






__declspec( dllexport ) void QPushButton_Destructor(void *object)
{
    delete ((PushButton*)object);
}




META_MAKRO(QPushButton,PushButton);









__declspec( dllexport ) void * __cdecl QPushButton_setAutoDefault(void *object, int b)
{
    if (b == -1)
    {
        ((QPushButton*)object)->setAutoDefault(true);
    } else
    {
        ((QPushButton*)object)->setAutoDefault(false);
    }
}



__declspec( dllexport ) void * __cdecl QPushButton_setDefault(void *object, int b)
{
    if (b == -1)
    {
        ((QPushButton*)object)->setDefault(true);
    } else
    {
        ((QPushButton*)object)->setDefault(false);
    }
}



__declspec( dllexport ) void * __cdecl QPushButton_setFlat(void *object, int b)
{
    if (b == -1)
    {
        ((QPushButton*)object)->setFlat(true);
    } else
    {
        ((QPushButton*)object)->setFlat(false);
    }
}



__declspec( dllexport ) int __cdecl QPushButton_text(void *object)
{
    QString s = ((QPushButton*)object)->text();
    int i;

    memcpy(&i,&s,4);
    return i;
}
}
