#include once "QWidget.bi"

declare sub QBoxLayout_getContentMargins cdecl lib "QtWrapper" alias "QLayout_getContentMargins" (byval object as any ptr, byval l as integer ptr, byval t as integer ptr, byval r as integer ptr, byval b as integer ptr)
declare sub QBoxLayout_setContentMargins cdecl lib "QtWrapper" alias "QLayout_setContentMargins" (byval object as any ptr, byval l as integer, byval t as integer, byval r as integer, byval b as integer)
declare sub QBoxLayout_removeWidget cdecl lib "QtWrapper" alias "QLayout_removeWidget" (byval object as any ptr, byval w as any ptr )
declare function QBoxLayout_parentWidget cdecl lib "QtWrapper" alias "QLayout_parentWidget" (byval object as any ptr) as any ptr

#macro QLayout_Interface()
declare sub getContentMargins (byval l as integer ptr, byval t as integer ptr, byval r as integer ptr, byval b as integer ptr)
declare sub setContentMargins (byval l as integer, byval t as integer, byval r as integer, byval b as integer)
declare sub removeWidget (byval w as QWidget ptr )
declare function parentWidget () as QWidget ptr

#endmacro




#macro QLayout_Extends(c)
sub c##.getContentMargins (byval l as integer ptr, byval t as integer ptr, byval r as integer ptr, byval b as integer ptr)
    QBoxLayout_getContentMargins(w_ptr,l,t,r,b)
end sub


sub c##.setContentMargins (byval l as integer, byval t as integer, byval r as integer, byval b as integer)
    QBoxLayout_setContentMargins(w_ptr,l,t,r,b)
end sub


sub c##.removeWidget (byval w as QWidget ptr )
    QBoxLayout_removeWidget(w_ptr,w->w_ptr)
end sub


function c##.parentWidget () as QWidget ptr
    return Q_WIDGET(QBoxLayout_parentWidget(w_ptr))
end function

#endmacro