#include once "QWidget.bi"
#include once "QDockWidget.bi"

declare function QMainWindow_Constructor cdecl lib "QtWrapper" alias "QMainWindow_Constructor" (byval parent as any ptr = 0, byval flags as integer) as any ptr
declare sub QMainWindow_Destructor cdecl lib "QtWrapper" alias "QMainWindow_Destructor" (byval object as any ptr)
declare sub QMainWindow_addDockWidget cdecl lib "QtWrapper" alias "QMainWindow_addDockWidget" (byval object as any ptr, byval area as integer, byval dock as any ptr)
declare sub QMainWindow_addDockWidget_2 cdecl lib "QtWrapper" alias "QMainWindow_addDockWidget_2" (byval object as any ptr, byval area as integer, byval dock as any ptr, byval o as integer)
declare sub QMainWindow_setCentralWidget cdecl lib "QtWrapper" alias "QMainWindow_setCentralWidget" (byval object as any ptr, byval widget as any ptr)
declare sub QMainWindow_addToolBar cdecl lib "QtWrapper" alias "QMainWindow_addToolBar" (byval object as any ptr, byval widget as any ptr)
declare sub QMainWindow_removeToolBar cdecl lib "QtWrapper" alias "QMainWindow_removeToolBar" (byval object as any ptr, byval widget as any ptr)
declare sub QMainWindow_removeDockWidget cdecl lib "QtWrapper" alias "QMainWindow_removeDockWidget" (byval object as any ptr, byval widget as any ptr)
declare sub QMainWindow_setMenuBar cdecl lib "QtWrapper" alias "QMainWindow_setMenuBar" (byval object as any ptr, byval widget as any ptr)
declare sub QMainWindow_setCallback cdecl lib "QtWrapper" alias "QMainWindow_setCallback" (byval object as any ptr, byval n as string, byval callback as any ptr)
declare sub QMainWindow_callDefault cdecl lib "QtWrapper" alias "QMainWindow_callDefault" (byval object as any ptr, byval n as string, byval e as any ptr)



type QMainWindow
    w_ptr as any ptr
    
    declare constructor (byval parent as any ptr = 0, byval flags as integer = 0)
    declare destructor ()
    
    declare sub addDockWidget(byval area as integer, byval dock as QDockWidget ptr)
    declare sub addDockWidget(byval area as integer, byval dock as QDockWidget ptr, byval o as integer)
    declare sub addToolBar(byval tb as any ptr)
    
    declare sub removeToolBar(byval tb as any ptr)
    declare sub removeDockWidget(byval dock as QDockWidget ptr)
    
    declare sub setCentralWidget(byval widget as QWidget ptr)
    declare sub setMenuBar(byval tb as any ptr)
    
    QWidget_Interface()
    declare sub setCallback (byval n as string,byval c as sub(byval object as any ptr, byval n as string, byval e1 as any ptr,byval e2 as any ptr,byval e3 as any ptr))
end type




constructor QMainWindow (byval parent as any ptr, byval flags as integer)
  w_ptr = QMainWindow_Constructor(parent,flags)
end constructor 


destructor QMainWindow ()
  QMainWindow_Destructor(w_ptr)
end destructor


sub QMainWindow.setCallback (byval n as string,byval c as sub(byval object as any ptr, byval n as string, byval e1 as any ptr,byval e2 as any ptr,byval e3 as any ptr))
    QMainWindow_setCallback(w_ptr,n,c)
end sub







sub QMainWindow.addDockWidget(byval area as integer, byval dock as QDockWidget ptr)
    QMainWindow_addDockWidget(w_ptr,area,dock->w_ptr)
end sub



sub QMainWindow.setCentralWidget(byval widget as QWidget ptr)
    QMainWindow_setCentralWidget(w_ptr,widget->w_ptr)
end sub



sub QMainWindow.addDockWidget(byval area as integer, byval dock as QDockWidget ptr, byval o as integer)
    QMainWindow_addDockWidget_2(w_ptr,area,dock->w_ptr,o)
end sub



sub QMainWindow.removeDockWidget(byval dock as QDockWidget ptr)
    QMainWindow_removeDockWidget(w_ptr,dock->w_ptr)
end sub



QWidget_Extends(QMainWindow)