#include <QtGui>
extern "C" {


__declspec( dllexport ) void * __cdecl QBoxLayout_Constructor(int dir, void *parent)
{
    return new QBoxLayout((QBoxLayout::Direction)dir,(QWidget*)parent);
}







__declspec( dllexport ) void QBoxLayout_Destructor(void *object)
{
    delete ((QBoxLayout*)object);
}





__declspec( dllexport ) void __cdecl QBoxLayout_addLayout(void *object, void *layout, int s)
{
    ((QBoxLayout*)object)->addLayout((QLayout*)layout,s);
}


__declspec( dllexport ) void __cdecl QBoxLayout_addSpaceItem(void *object, void *s)
{
    ((QBoxLayout*)object)->addSpacerItem((QSpacerItem*)s);
}


__declspec( dllexport ) void __cdecl QBoxLayout_addSpacing(void *object, int s)
{
    ((QBoxLayout*)object)->addSpacing(s);
}


__declspec( dllexport ) void __cdecl QBoxLayout_addStretch(void *object, int s)
{
    ((QBoxLayout*)object)->addStretch(s);
}


__declspec( dllexport ) void __cdecl QBoxLayout_addStrut(void *object, int s)
{
    ((QBoxLayout*)object)->addStrut(s);
}


__declspec( dllexport ) void __cdecl QBoxLayout_addWidget(void *object, void *w, int s, int a)
{
    ((QBoxLayout*)object)->addWidget((QWidget*)w,s,(Qt::Alignment)a);
}









__declspec( dllexport ) void __cdecl QBoxLayout_insertLayout(void *object, int index, void *layout, int s)
{
    ((QBoxLayout*)object)->insertLayout(index,(QLayout*)layout,s);
}


__declspec( dllexport ) void __cdecl QBoxLayout_insertSpaceItem(void *object, int index, void *s)
{
    ((QBoxLayout*)object)->insertSpacerItem(index,(QSpacerItem*)s);
}


__declspec( dllexport ) void __cdecl QBoxLayout_insertSpacing(void *object, int index, int s)
{
    ((QBoxLayout*)object)->insertSpacing(index,s);
}


__declspec( dllexport ) void __cdecl QBoxLayout_insertStretch(void *object, int index, int s)
{
    ((QBoxLayout*)object)->insertStretch(index,s);
}


__declspec( dllexport ) void __cdecl QBoxLayout_insertWidget(void *object, int index, void *w, int s, int a)
{
    ((QBoxLayout*)object)->insertWidget(index,(QWidget*)w,s,(Qt::Alignment)a);
}






__declspec( dllexport ) void __cdecl QBoxLayout_setStretch(void *object, int index, int s)
{
    ((QBoxLayout*)object)->setStretch(index,s);
}



__declspec( dllexport ) void __cdecl QBoxLayout_setSpacing(void *object, int s)
{
    ((QBoxLayout*)object)->setSpacing(s);
}



__declspec( dllexport ) void __cdecl QBoxLayout_setStretchFactor(void *object, void *w, int s)
{
    ((QBoxLayout*)object)->setStretchFactor((QWidget*)w,s);
}



__declspec( dllexport ) void __cdecl QBoxLayout_setStretchFactor_2(void *object, void *l, int s)
{
    ((QBoxLayout*)object)->setStretchFactor((QLayout*)l,s);
}


}
