#include <QtGui>
extern "C" {


__declspec( dllexport ) void *QByteArray_Constructor()
{
    return new QByteArray();
}




__declspec( dllexport ) void *QByteArray_Constructor_2(const char *str)
{
    return new QByteArray(str);
}




__declspec( dllexport ) void *QByteArray_Constructor_3(const char *str,int size)
{
    return new QByteArray(str,size);
}



__declspec( dllexport ) void *QByteArray_Constructor_4(int size,char ch)
{
    return new QByteArray(size,ch);
}




__declspec( dllexport ) void QByteArray_Destructor(void *object)
{
    delete ((QByteArray*)object);
}




__declspec( dllexport ) void *QByteArray_LET(void *object, void *object2)
{
    memcpy(object,object2,sizeof(QByteArray));
    return object;
}







__declspec( dllexport ) void QByteArray_Append(void *object,void *string)
{
    QString s;
    memcpy(&s,string,sizeof(QString));
    ((QByteArray*)object)->append(s);
}


__declspec( dllexport ) void QByteArray_Append_2(void *object, char *str)
{
    ((QByteArray*)object)->append(str);
}


__declspec( dllexport ) void QByteArray_Append_3(void *object, char *str,int len)
{
    ((QByteArray*)object)->append(str,len);
}


__declspec( dllexport ) void QByteArray_Append_4(void *object, char ch)
{
    ((QByteArray*)object)->append(ch);
}





__declspec( dllexport ) char QByteArray_At(void *object, int i)
{
    return ((QByteArray*)object)->at(i);
}


__declspec( dllexport ) int QByteArray_Capacity(void *object)
{
    return ((QByteArray*)object)->capacity();
}


__declspec( dllexport ) void QByteArray_Chop(void *object, int i)
{
    ((QByteArray*)object)->chop(i);
}


__declspec( dllexport ) void QByteArray_Clear(void *object)
{
    ((QByteArray*)object)->clear();
}




__declspec( dllexport ) const char *QByteArray_ConstData(void *object, int i)
{
    return ((QByteArray*)object)->constData();
}



__declspec( dllexport ) int QByteArray_Contains(void *object, char *str)
{
    bool b = ((QByteArray*)object)->contains(str);
    if (b == true)
        return -1;
    return 0;
}



__declspec( dllexport ) int QByteArray_Contains_2(void *object, char ch)
{
    bool b = ((QByteArray*)object)->contains(ch);
    if (b == true)
        return -1;
    return 0;
}









__declspec( dllexport ) int QByteArray_Count(void *object, char *str)
{
    return ((QByteArray*)object)->count(str);
}



__declspec( dllexport ) int QByteArray_Count_2(void *object, char ch)
{
    return ((QByteArray*)object)->count(ch);
}



__declspec( dllexport ) int QByteArray_Count_3(void *object)
{
    return ((QByteArray*)object)->count();
}










__declspec( dllexport ) char *QByteArray_Data(void *object)
{
    return ((QByteArray*)object)->data();
}


__declspec( dllexport ) const char *QByteArray_Data_2(void *object)
{
    return ((QByteArray*)object)->data();
}






__declspec( dllexport ) int QByteArray_EndsWith(void *object, char *str)
{
    bool b = ((QByteArray*)object)->endsWith(str);
    if (b == true)
        return -1;
    return 0;
}



__declspec( dllexport ) int QByteArray_EndsWith_2(void *object, char ch)
{
    bool b = ((QByteArray*)object)->endsWith(ch);
    if (b == true)
        return -1;
    return 0;
}








__declspec( dllexport ) int QByteArray_IndexOf(void *object, char *str,int f)
{
    return ((QByteArray*)object)->indexOf(str,f);
}



__declspec( dllexport ) int QByteArray_IndexOf_2(void *object, char ch,int f)
{
    return ((QByteArray*)object)->indexOf(ch,f);
}



__declspec( dllexport ) int QByteArray_IndexOf_3(void *object, void *string,int f)
{
    QString s;
    memcpy(&s,string,sizeof(QString));
    return ((QByteArray*)object)->indexOf(s,f);
}








__declspec( dllexport ) int QByteArray_isEmpty(void *object)
{
    bool b = ((QByteArray*)object)->isEmpty();
    if (b == true)
        return -1;
    return 0;
}



__declspec( dllexport ) int QByteArray_isNull(void *object, char ch)
{
    bool b = ((QByteArray*)object)->isNull();
    if (b == true)
        return -1;
    return 0;
}










__declspec( dllexport ) int QByteArray_LastIndexOf(void *object, char *str,int f)
{
    return ((QByteArray*)object)->lastIndexOf(str,f);
}



__declspec( dllexport ) int QByteArray_LastIndexOf_2(void *object, char ch,int f)
{
    return ((QByteArray*)object)->lastIndexOf(ch,f);
}



__declspec( dllexport ) int QByteArray_LastIndexOf_3(void *object, void *string,int f)
{
    QString s;
    memcpy(&s,string,sizeof(QString));
    return ((QByteArray*)object)->lastIndexOf(s,f);
}
}
