#include <QtGui>
#include "Makros.h"

class DockWidget : public QDockWidget
{
public:
    QMap<QString,void (*)(void *object,char *name, void *event)> map;
    DockWidget(QWidget *parent, Qt::WindowFlags flags) : QDockWidget(parent, flags) {}
    DockWidget(QString titel,QWidget *parent, Qt::WindowFlags flags) : QDockWidget(titel,parent, flags) {}

    META_MAKRO2(QDockWidget,DockWidget);

};



extern "C" {


__declspec( dllexport ) void *QDockWidget_Constructor(void *parent, int flags)
{
    return new DockWidget((QWidget*)parent,(Qt::WindowFlags)flags);
}


__declspec( dllexport ) void *QDockWidget_Constructor_2(char *titel, void *parent, int flags)
{
    return new DockWidget(titel,(QWidget*)parent,(Qt::WindowFlags)flags);
}



__declspec( dllexport ) void QDockWidget_Destructor(void *object)
{
    delete ((QDockWidget*)object);
}

META_MAKRO(QDockWidget,DockWidget);




__declspec( dllexport ) void QDockWidget_setAllowedAreas(void *object,int areas)
{
    ((QDockWidget*)object)->setAllowedAreas((Qt::DockWidgetArea)areas);
}



















}
