#include <QtGui>
#include "Makros.h"

class MainWindow : public QMainWindow
{
public:
    QMap<QString,void (*)(void *object,char *name, void *event)> map;

    MainWindow(QWidget *parent, Qt::WindowFlags flags) : QMainWindow(parent, flags) {}

    META_MAKRO2(QMainWindow,MainWindow);

};



extern "C" {


__declspec( dllexport ) void *QMainWindow_Constructor(void *parent, int flags)
{
    return (QMainWindow*)(new MainWindow((QWidget*)parent,(Qt::WindowFlags)flags));
}


__declspec( dllexport ) void QMainWindow_Destructor(void *object)
{
    delete ((QMainWindow*)object);
}


META_MAKRO(QMainWindow,MainWindow);










__declspec( dllexport ) void QMainWindow_addDockWidget(void *object,int areas,void *dock)
{
    ((QMainWindow*)object)->addDockWidget((Qt::DockWidgetArea) areas,(QDockWidget*)dock);
}



__declspec( dllexport ) void QMainWindow_addDockWidget_2(void *object,int areas,void *dock, int o)
{
    ((QMainWindow*)object)->addDockWidget((Qt::DockWidgetArea) areas,(QDockWidget*)dock,(Qt::Orientation)o);
}



__declspec( dllexport ) void QMainWindow_setCentralWidget(void *object,void *widget)
{
    ((QMainWindow*)object)->setCentralWidget((QWidget*)widget);
}



__declspec( dllexport ) void QMainWindow_addToolBar(void *object,void *toolbar)
{
    ((QMainWindow*)object)->addToolBar((QToolBar*)toolbar);
}




__declspec( dllexport ) void QMainWindow_removeDockWidget(void *object,void *widget)
{
    ((QMainWindow*)object)->removeDockWidget((QDockWidget*)widget);
}



__declspec( dllexport ) void QMainWindow_removeToolBar(void *object,void *widget)
{
    ((QMainWindow*)object)->removeToolBar((QToolBar*)widget);
}





__declspec( dllexport ) void QMainWindow_setMenuBar(void *object,void *menu)
{
    ((QMainWindow*)object)->setMenuBar((QMenuBar*)menu);
}


}

