#ifndef MAKROS_H
#define MAKROS_H

#define META_MAKRO(c,cn) __declspec( dllexport ) void __cdecl c##_setCallback(void *object, char *name, void (*Callback)(void *object,char *name, void *event))\
{\
 ((cn*)object)->map.insert(name,Callback);\
}\
\
\
\
\
__declspec( dllexport ) void __cdecl c##_callDefault(void *object, char *name, void *e)\
{\
    if (name == "changeEvent")\
    {\
        ((cn*)object)->changeEvent_default((QEvent*)e);\
    } else if (name == "closeEvent")\
    {\
        ((cn*)object)->closeEvent_default((QCloseEvent*)e);\
    } else if (name == "contextMenuEvent")\
    {\
        ((cn*)object)->contextMenuEvent_default((QContextMenuEvent*)e);\
    } else if (name == "dragEnterEvent")\
    {\
        ((cn*)object)->dragEnterEvent_default((QDragEnterEvent *)e);\
    } else if (name == "dragLeaveEvent")\
    {\
        ((cn*)object)->dragLeaveEvent_default((QDragLeaveEvent *)e);\
    } else if (name == "dragMoveEvent")\
    {\
        ((cn*)object)->dragMoveEvent_default((QDragMoveEvent *)e);\
    } else if (name == "dropEvent")\
    {\
        ((cn*)object)->dropEvent_default((QDropEvent*)e);\
    } else if (name == "enterEvent")\
    {\
        ((cn*)object)->enterEvent_default((QEvent*)e);\
    } else if (name == "wheelEvent")\
    {\
        ((cn*)object)->wheelEvent_default((QWheelEvent*)e);\
    } else if (name == "showEvent")\
    {\
        ((cn*)object)->showEvent_default((QShowEvent*)e);\
    } else if (name == "resizeEvent")\
    {\
        ((cn*)object)->resizeEvent_default((QResizeEvent*)e);\
    } else if (name == "paintEvent")\
    {\
        ((cn*)object)->paintEvent_default((QPaintEvent*)e);\
    } else if (name == "moveEvent")\
    {\
        ((cn*)object)->moveEvent_default((QMoveEvent*)e);\
    } else if (name == "mouseReleaseEvent")\
    {\
        ((cn*)object)->mouseReleaseEvent_default((QMouseEvent*)e);\
    } else if (name == "mousePressEvent")\
    {\
        ((cn*)object)->mousePressEvent_default((QMouseEvent*)e);\
    } else if (name == "mouseMoveEvent")\
    {\
        ((cn*)object)->mouseMoveEvent_default((QMouseEvent*)e);\
    } else if (name == "mouseDoubleClickEvent")\
    {\
        ((cn*)object)->mouseDoubleClickEvent_default((QMouseEvent*)e);\
    } else if (name == "leaveEvent")\
    {\
        ((cn*)object)->leaveEvent_default((QEvent*)e);\
    } else if (name == "keyReleaseEvent")\
    {\
        ((cn*)object)->keyReleaseEvent_default((QKeyEvent*)e);\
    } else if (name == "keyPressEvent")\
    {\
        ((cn*)object)->keyPressEvent_default((QKeyEvent*)e);\
    } else if (name == "hideEvent")\
    {\
        ((cn*)object)->hideEvent_default((QHideEvent*)e);\
    }\
}







#define META_MAKRO2(c,cn) void keyPressEvent_default(QKeyEvent *e) {c::keyPressEvent(e);}\
void mouseMoveEvent_default(QMouseEvent *e) {c::mouseMoveEvent(e);}\
void mousePressEvent_default (QMouseEvent *e) {c::mousePressEvent(e);}\
void mouseReleaseEvent_default (QMouseEvent *e) {c::mouseReleaseEvent(e);}\
void moveEvent_default (QMoveEvent *e) {c::moveEvent(e);}\
void paintEvent_default (QPaintEvent *e) {c::paintEvent(e);}\
void resizeEvent_default (QResizeEvent *e) {c::resizeEvent(e);}\
void showEvent_default (QShowEvent *e) {c::showEvent(e);}\
void wheelEvent_default ( QWheelEvent * e) {c::wheelEvent(e);}\
void mouseDoubleClickEvent_default (QMouseEvent *e) {c::mouseDoubleClickEvent(e);}\
void leaveEvent_default ( QEvent *e) {c::leaveEvent(e);}\
void keyReleaseEvent_default (QKeyEvent *e) {c::keyReleaseEvent(e);}\
\
void changeEvent_default ( QEvent * e) {c::changeEvent(e);}\
void closeEvent_default ( QCloseEvent * e) {c::closeEvent(e);}\
void contextMenuEvent_default ( QContextMenuEvent * e) {c::contextMenuEvent(e);}\
void dragEnterEvent_default ( QDragEnterEvent * e) {c::dragEnterEvent(e);}\
void dragLeaveEvent_default ( QDragLeaveEvent * e) {c::dragLeaveEvent(e);}\
void dragMoveEvent_default ( QDragMoveEvent * e) {c::dragMoveEvent(e);}\
void dropEvent_default ( QDropEvent * e) {c::dropEvent(e);}\
void enterEvent_default ( QEvent * e) {c::enterEvent(e);}\
\
void hideEvent_default ( QHideEvent * e) {c::hideEvent(e);}\
void focusInEvent_default ( QFocusEvent * e) {c::focusInEvent(e);}\
void inputMethodEvent_default ( QInputMethodEvent * e) {c::inputMethodEvent(e);}\
\
\
protected:\
    void keyPressEvent(QKeyEvent *e) {if (map.contains("keyPressEvent") == true){map.value("keyPressEvent")(this,"keyPressEvent",e);} else {c::keyPressEvent(e);}}\
    void mouseMoveEvent(QMouseEvent *e) {if (map.contains("mouseMoveEvent") == true){map.value("mouseMoveEvent")(this,"mouseMoveEvent",e);} else {c::mouseMoveEvent(e);}}\
    void mousePressEvent (QMouseEvent *e) {if (map.contains("mousePressEvent") == true){map.value("mousePressEvent")(this,"mousePressEvent",e);} else {c::mousePressEvent(e);}}\
    void mouseReleaseEvent (QMouseEvent *e) {if (map.contains("mouseReleaseEvent") == true){map.value("mouseReleaseEvent")(this,"mouseReleaseEvent",e);} else {c::mouseReleaseEvent(e);}}\
    void moveEvent (QMoveEvent *e) {if (map.contains("moveEvent") == true){map.value("moveEvent")(this,"moveEvent",e);} else {c::moveEvent(e);}}\
    void paintEvent (QPaintEvent *e) {if (map.contains("paintEvent") == true){map.value("paintEvent")(this,"paintEvent",e);} else {c::paintEvent(e);}}\
    void resizeEvent (QResizeEvent *e) {if (map.contains("resizeEvent") == true){map.value("resizeEvent")(this,"resizeEvent",e);} else {c::resizeEvent(e);}}\
    void showEvent (QShowEvent *e) {if (map.contains("showEvent") == true){map.value("showEvent")(this,"showEvent",e);} else {c::showEvent(e);}}\
    void wheelEvent ( QWheelEvent * e) {if (map.contains("wheelEvent") == true){map.value("wheelEvent")(this,"wheelEvent",e);} else {c::wheelEvent(e);}}\
    void mouseDoubleClickEvent (QMouseEvent *e) {if (map.contains("mouseDoubleClickEvent") == true){map.value("mouseDoubleClickEvent")(this,"mouseDoubleClickEvent",e);} else {c::mouseDoubleClickEvent(e);}}\
    void leaveEvent ( QEvent *e) {if (map.contains("leaveEvent") == true){map.value("leaveEvent")(this,"leaveEvent",e);} else {c::leaveEvent(e);}}\
    void keyReleaseEvent (QKeyEvent *e) {if (map.contains("keyReleaseEvent") == true){map.value("keyReleaseEvent")(this,"keyReleaseEvent",e);} else {c::keyReleaseEvent(e);}}\
\
    void changeEvent ( QEvent * e) {if (map.contains("changeEvent") == true){map.value("changeEvent")(this,"changeEvent",e);} else {c::changeEvent(e);}}\
    void closeEvent ( QCloseEvent * e) {if (map.contains("closeEvent") == true){map.value("closeEvent")(this,"closeEvent",e);} else {c::closeEvent(e);}}\
    void contextMenuEvent ( QContextMenuEvent * e) {if (map.contains("contextMenuEvent") == true){map.value("contextMenuEvent")(this,"contextMenuEvent",e);} else {c::contextMenuEvent(e);}}\
    void dragEnterEvent ( QDragEnterEvent * e) {if (map.contains("dragEnterEvent") == true){map.value("dragEnterEvent")(this,"dragEnterEvent",e);} else {c::dragEnterEvent(e);}}\
    void dragLeaveEvent ( QDragLeaveEvent * e) {if (map.contains("dragLeaveEvent") == true){map.value("dragLeaveEvent")(this,"dragLeaveEvent",e);} else {c::dragLeaveEvent(e);}}\
    void dragMoveEvent ( QDragMoveEvent * e) {if (map.contains("dragMoveEvent") == true){map.value("dragMoveEvent")(this,"dragMoveEvent",e);} else {c::dragMoveEvent(e);}}\
    void dropEvent ( QDropEvent * e) {if (map.contains("dropEvent") == true){map.value("dropEvent")(this,"dropEvent",e);} else {c::dropEvent(e);}}\
    void enterEvent ( QEvent * e) {if (map.contains("enterEvent") == true){map.value("enterEvent")(this,"enterEvent",e);} else {c::enterEvent(e);}}\
\
    void hideEvent ( QHideEvent * e) {if (map.contains("hideEvent") == true){map.value("hideEvent")(this,"hideEvent",e);} else {c::hideEvent(e);}}\
    void focusInEvent ( QFocusEvent * e) {if (map.contains("focusInEvent") == true){map.value("focusInEvent")(this,"focusInEvent",e);} else {c::focusInEvent(e);}}\
    void inputMethodEvent ( QInputMethodEvent * e) {if (map.contains("inputMethodEvent") == true){map.value("inputMethodEvent")(this,"inputMethodEvent",e);} else {c::inputMethodEvent(e);}}\




#endif // MAKROS_H
